/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package telas;

import Conection.BancoDados;
import ModeloControle.ControleUsuario;
import java.sql.SQLException;
import java.util.ArrayList;
import javax.swing.JOptionPane;
import javax.swing.ListSelectionModel;
import modeloMetodos.Tabela;
import modeloMetodos.Usuarios;

/**
 *
 * @author soare
 */
public class CadastroUsuario extends javax.swing.JFrame {
     
    Usuarios usu = new Usuarios();
    ControleUsuario controlusu = new ControleUsuario();
    BancoDados conexao = new BancoDados();
    int flag =0;
    
    public CadastroUsuario() {
        initComponents();
        preencherTabela("select *from usuarios order by nome_usuario");
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jPanel1 = new javax.swing.JPanel();
        jLabel3 = new javax.swing.JLabel();
        jLabel4 = new javax.swing.JLabel();
        jLabel5 = new javax.swing.JLabel();
        jLabel6 = new javax.swing.JLabel();
        jTextFieldUsuario = new javax.swing.JTextField();
        jPasswordFieldSenha = new javax.swing.JPasswordField();
        jPasswordFieldConfirmSenha = new javax.swing.JPasswordField();
        jComboBoxTipo = new javax.swing.JComboBox<>();
        jButtonNovo = new javax.swing.JButton();
        jButtonSalvar = new javax.swing.JButton();
        jButtonAlterar = new javax.swing.JButton();
        jButtonExcluir = new javax.swing.JButton();
        jButtonCancelar = new javax.swing.JButton();
        jTextFieldPesquisar = new javax.swing.JTextField();
        jButtonBuscar = new javax.swing.JButton();
        jScrollPane1 = new javax.swing.JScrollPane();
        jTableUsuario = new javax.swing.JTable();
        jTextFieldCod = new javax.swing.JTextField();
        jLabel2 = new javax.swing.JLabel();
        jLabel1 = new javax.swing.JLabel();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);

        jPanel1.setBorder(javax.swing.BorderFactory.createEtchedBorder());

        jLabel3.setFont(new java.awt.Font("Tahoma", 1, 14)); // NOI18N
        jLabel3.setText("Usuario:");

        jLabel4.setFont(new java.awt.Font("Tahoma", 1, 14)); // NOI18N
        jLabel4.setText("Senha:");

        jLabel5.setFont(new java.awt.Font("Tahoma", 1, 14)); // NOI18N
        jLabel5.setText("Confirmar Senha:");

        jLabel6.setFont(new java.awt.Font("Tahoma", 1, 14)); // NOI18N
        jLabel6.setText("Tipo de Usuario:");

        jTextFieldUsuario.setEnabled(false);

        jPasswordFieldSenha.setEnabled(false);

        jPasswordFieldConfirmSenha.setEnabled(false);

        jComboBoxTipo.setModel(new javax.swing.DefaultComboBoxModel<>(new String[] { "Administrador", "Medico", "Atendente" }));

        jButtonNovo.setFont(new java.awt.Font("Tahoma", 1, 13)); // NOI18N
        jButtonNovo.setText("NOVO");
        jButtonNovo.setMaximumSize(new java.awt.Dimension(99, 25));
        jButtonNovo.setMinimumSize(new java.awt.Dimension(99, 25));
        jButtonNovo.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonNovoActionPerformed(evt);
            }
        });

        jButtonSalvar.setFont(new java.awt.Font("Tahoma", 1, 13)); // NOI18N
        jButtonSalvar.setText("SALVAR");
        jButtonSalvar.setEnabled(false);
        jButtonSalvar.setMaximumSize(new java.awt.Dimension(99, 25));
        jButtonSalvar.setMinimumSize(new java.awt.Dimension(99, 25));
        jButtonSalvar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonSalvarActionPerformed(evt);
            }
        });

        jButtonAlterar.setFont(new java.awt.Font("Tahoma", 1, 13)); // NOI18N
        jButtonAlterar.setText("ALTERAR");
        jButtonAlterar.setEnabled(false);
        jButtonAlterar.setMaximumSize(new java.awt.Dimension(99, 25));
        jButtonAlterar.setMinimumSize(new java.awt.Dimension(99, 25));
        jButtonAlterar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonAlterarActionPerformed(evt);
            }
        });

        jButtonExcluir.setFont(new java.awt.Font("Tahoma", 1, 13)); // NOI18N
        jButtonExcluir.setText("EXCLUIR");
        jButtonExcluir.setEnabled(false);
        jButtonExcluir.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonExcluirActionPerformed(evt);
            }
        });

        jButtonCancelar.setFont(new java.awt.Font("Tahoma", 1, 13)); // NOI18N
        jButtonCancelar.setText("CANCELAR");
        jButtonCancelar.setEnabled(false);
        jButtonCancelar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonCancelarActionPerformed(evt);
            }
        });

        jTextFieldPesquisar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jTextFieldPesquisarActionPerformed(evt);
            }
        });

        jButtonBuscar.setText("Buscar");
        jButtonBuscar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonBuscarActionPerformed(evt);
            }
        });

        jTableUsuario.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {},
                {},
                {},
                {}
            },
            new String [] {

            }
        ));
        jTableUsuario.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jTableUsuarioMouseClicked(evt);
            }
        });
        jScrollPane1.setViewportView(jTableUsuario);

        jTextFieldCod.setEnabled(false);

        jLabel2.setFont(new java.awt.Font("Tahoma", 1, 13)); // NOI18N
        jLabel2.setText("Código:");

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jButtonSalvar, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jButtonNovo, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addGap(71, 71, 71)
                        .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jLabel3)
                            .addComponent(jLabel4)
                            .addComponent(jLabel2))
                        .addGap(18, 18, 18)
                        .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jTextFieldUsuario, javax.swing.GroupLayout.PREFERRED_SIZE, 260, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jPasswordFieldSenha, javax.swing.GroupLayout.PREFERRED_SIZE, 259, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jTextFieldCod, javax.swing.GroupLayout.PREFERRED_SIZE, 67, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addGap(17, 17, 17)
                        .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                            .addComponent(jLabel6)
                            .addComponent(jLabel5))
                        .addGap(18, 18, 18)
                        .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jPasswordFieldConfirmSenha, javax.swing.GroupLayout.PREFERRED_SIZE, 213, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jComboBoxTipo, javax.swing.GroupLayout.PREFERRED_SIZE, 164, javax.swing.GroupLayout.PREFERRED_SIZE)))
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                            .addComponent(jButtonCancelar, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .addComponent(jButtonAlterar, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .addComponent(jButtonExcluir, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                        .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(jPanel1Layout.createSequentialGroup()
                                .addGap(159, 159, 159)
                                .addComponent(jTextFieldPesquisar, javax.swing.GroupLayout.PREFERRED_SIZE, 405, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addGap(33, 33, 33)
                                .addComponent(jButtonBuscar, javax.swing.GroupLayout.PREFERRED_SIZE, 100, javax.swing.GroupLayout.PREFERRED_SIZE))
                            .addGroup(jPanel1Layout.createSequentialGroup()
                                .addGap(120, 120, 120)
                                .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 586, javax.swing.GroupLayout.PREFERRED_SIZE)))))
                .addContainerGap(141, Short.MAX_VALUE))
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addGap(11, 11, 11)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jTextFieldCod, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel2))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jButtonNovo, javax.swing.GroupLayout.PREFERRED_SIZE, 57, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel3)
                    .addComponent(jTextFieldUsuario, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel6)
                    .addComponent(jComboBoxTipo, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(18, 18, 18)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addComponent(jButtonSalvar, javax.swing.GroupLayout.PREFERRED_SIZE, 57, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(20, 20, 20)
                        .addComponent(jButtonCancelar, javax.swing.GroupLayout.PREFERRED_SIZE, 57, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(18, 18, 18)
                        .addComponent(jButtonAlterar, javax.swing.GroupLayout.PREFERRED_SIZE, 57, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(18, 18, 18)
                        .addComponent(jButtonExcluir, javax.swing.GroupLayout.PREFERRED_SIZE, 57, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                                .addComponent(jLabel4)
                                .addComponent(jPasswordFieldSenha, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                            .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                                .addComponent(jPasswordFieldConfirmSenha, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addComponent(jLabel5)))
                        .addGap(33, 33, 33)
                        .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(jTextFieldPesquisar, javax.swing.GroupLayout.PREFERRED_SIZE, 28, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jButtonBuscar, javax.swing.GroupLayout.PREFERRED_SIZE, 35, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addGap(30, 30, 30)
                        .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 262, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addContainerGap(184, Short.MAX_VALUE))
        );

        jLabel1.setFont(new java.awt.Font("Tahoma", 1, 18)); // NOI18N
        jLabel1.setText("CADASTRO DE USUARIO");

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addGap(390, 390, 390)
                        .addComponent(jLabel1))
                    .addGroup(layout.createSequentialGroup()
                        .addGap(21, 21, 21)
                        .addComponent(jPanel1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addComponent(jLabel1)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jPanel1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(167, 167, 167))
        );

        setSize(new java.awt.Dimension(1067, 600));
        setLocationRelativeTo(null);
    }// </editor-fold>//GEN-END:initComponents

    private void jTextFieldPesquisarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jTextFieldPesquisarActionPerformed
        usu.setPesquisa_usario(jTextFieldPesquisar.getText());
        Usuarios model = controlusu.buscaUsuario(usu); // enviando por parametro o que o usuario diigtou
        
        jTextFieldUsuario.setText(model.getNome_usuario());
        jTextFieldCod.setText(String.valueOf(model.getCod_usuario()));
        jComboBoxTipo.setSelectedItem(model.getTipo_usuario());
        jPasswordFieldSenha.setText(model.getSenha_usuario());
        jPasswordFieldConfirmSenha.setText(model.getSenha_usuario());
 
        preencherTabela("select *from usuarios order by nome_usuario");
    }//GEN-LAST:event_jTextFieldPesquisarActionPerformed

    private void jButtonNovoActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonNovoActionPerformed
       //Ao clicar em novo habilita os campos abaixo
       flag =1;
        jTextFieldUsuario.setEnabled(true);
        jComboBoxTipo.setEnabled(true);
        jPasswordFieldSenha.setEnabled(true);
        jPasswordFieldConfirmSenha.setEnabled(true);
        
        jButtonSalvar.setEnabled(true); //ativa botão de salvar
        jButtonCancelar.setEnabled(true);// ativa botão de calcelar
        jButtonAlterar.setEnabled(false);
        jButtonExcluir.setEnabled(false);
        jTextFieldUsuario.setText("");
        jPasswordFieldSenha.setText("");
        jPasswordFieldConfirmSenha.setText("");
        jTextFieldPesquisar.setEnabled(false);
        jButtonBuscar.setEnabled(false);
        preencherTabela("select *from usuarios order by nome_usuario");
    }//GEN-LAST:event_jButtonNovoActionPerformed

    private void jButtonSalvarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonSalvarActionPerformed
        
        if(jTextFieldUsuario.getText().isEmpty()){ //se o campo estiver em branco, mostra a msg abaixo
            JOptionPane.showMessageDialog(null, "Preencha o Usuario para continuar");
            jTextFieldUsuario.requestFocus();
        } 
        
        else if(jPasswordFieldSenha.getText().isEmpty()){//se o campo estiver em branco, mostra a msg abaixo
            JOptionPane.showMessageDialog(null, "Preencha a SENHA para continuar");
            jPasswordFieldSenha.requestFocus();   
        } else if(jPasswordFieldConfirmSenha.getText().isEmpty()){//se o campo estiver em branco, mostra a msg abaixo
            JOptionPane.showMessageDialog(null, "Confirma senha para continuar");
            jPasswordFieldConfirmSenha.requestFocus(); 
        
        }else 
        if (jPasswordFieldSenha.getText().equals(jPasswordFieldConfirmSenha.getText())){//verifica se os numeros inseridos são iguais, se sim salva usuario
        if (flag ==1){ //se for cadastrado Novo
       usu.setNome_usuario(jTextFieldUsuario.getText());// valor que usuario digitou
       usu.setTipo_usuario((String)jComboBoxTipo.getSelectedItem());
       usu.setSenha_usuario(jPasswordFieldSenha.getText());
      
       controlusu.Salvar(usu);
       
       //depois de salvar, vai limpar os campos
       jTextFieldCod.setText("");
       jTextFieldUsuario.setText("");
       jPasswordFieldSenha.setText("");
       jPasswordFieldConfirmSenha.setText("");
      
       //volta a ficar bloqueado para o usuario até que que clique em Novo
        jTextFieldUsuario.setEnabled(false);
        jComboBoxTipo.setEnabled(false);
        jPasswordFieldSenha.setEnabled(false);
        jPasswordFieldConfirmSenha.setEnabled(false);
        jButtonSalvar.setEnabled(false);
        jButtonCancelar.setEnabled(false);
        jTextFieldPesquisar.setEnabled(true);
        jButtonBuscar.setEnabled(true);  
         preencherTabela("select *from usuarios order by nome_usuario");
    }//GEN-LAST:event_jButtonSalvarActionPerformed
        else{
       usu.setCod_usuario(Integer.parseInt(jTextFieldCod.getText()));
       usu.setNome_usuario(jTextFieldUsuario.getText());// valor que usuario digitou
       usu.setTipo_usuario((String)jComboBoxTipo.getSelectedItem());
       usu.setSenha_usuario(jPasswordFieldSenha.getText());
       controlusu.Alterar(usu);
       jTextFieldCod.setText("");
       jTextFieldUsuario.setText("");
       jPasswordFieldSenha.setText("");
       jPasswordFieldConfirmSenha.setText("");
      
       //volta a ficar bloqueado para o usuario até que que clique em Novo
        jTextFieldUsuario.setEnabled(false);
        jComboBoxTipo.setEnabled(false);
        jPasswordFieldSenha.setEnabled(false);
        jPasswordFieldConfirmSenha.setEnabled(false);
        jButtonSalvar.setEnabled(false);
        jButtonCancelar.setEnabled(false);
        jTextFieldPesquisar.setEnabled(true);
        jButtonBuscar.setEnabled(true);
        preencherTabela("select *from usuarios order by nome_usuario");
        }
        }
        else{
           JOptionPane.showMessageDialog(null, "Senhas não são iguais. Confirmar novamente");
            //jPasswordFieldConfirmSenha.requestFocus();   
        }
    }
    
        
    private void jButtonBuscarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonBuscarActionPerformed
        
        usu.setPesquisa_usario(jTextFieldPesquisar.getText()); // o que o usuario digitar no campo vai para o metodo setPesquisa
        Usuarios model = controlusu.buscaUsuario(usu); // chamando o metodo enviando por parâmetro o que o usuario digitar
        
    
        jTextFieldUsuario.setText(model.getNome_usuario());
        jTextFieldCod.setText(String.valueOf(model.getCod_usuario()));
        jComboBoxTipo.setSelectedItem(model.getTipo_usuario());
        jPasswordFieldSenha.setText(model.getSenha_usuario());
        jPasswordFieldConfirmSenha.setText(model.getSenha_usuario());
        
      
        jTextFieldCod.setText("");
        jTextFieldUsuario.setText("");
        jPasswordFieldSenha.setText("");
        jPasswordFieldConfirmSenha.setText("");
        jTextFieldPesquisar.setText("");
       
        preencherTabela("SELECT *from usuarios WHERE nome_usuario like '%" +usu.getPesquisa_usario()+ "%'");
 
       preencherTabela("select *from usuarios order by nome_usuario");

    }//GEN-LAST:event_jButtonBuscarActionPerformed

    private void jButtonAlterarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonAlterarActionPerformed
         flag =2;
        jTextFieldUsuario.setEnabled(true);
        jComboBoxTipo.setEnabled(true);
        jPasswordFieldSenha.setEnabled(true);
        jPasswordFieldConfirmSenha.setEnabled(true);
         
        jButtonSalvar.setEnabled(true); //ativa botão de salvar
        jButtonCancelar.setEnabled(true);// ativa botão de calcelar
        jButtonAlterar.setEnabled(false);
        jButtonNovo.setEnabled(false);
        jButtonExcluir.setEnabled(false);
       
        preencherTabela("select *from usuarios order by nome_usuario");
         jTextFieldCod.setText("");
        jTextFieldUsuario.setText("");
        jPasswordFieldSenha.setText("");
        jPasswordFieldConfirmSenha.setText("");
      
    }//GEN-LAST:event_jButtonAlterarActionPerformed

    private void jButtonExcluirActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonExcluirActionPerformed
        int resposta =0; // aguardar resposta do usuario
        resposta = JOptionPane.showConfirmDialog(rootPane, "Confirma a exclusão do usuário?");
        if (resposta == JOptionPane.YES_OPTION){
            usu.setCod_usuario(Integer.parseInt(jTextFieldCod.getText()));
            controlusu.Excluir(usu);
        // limpar os campos
         jTextFieldCod.setText("");
           jTextFieldUsuario.setText("");
           jPasswordFieldSenha.setText("");
           jPasswordFieldConfirmSenha.setText("");
           
           //volta a ficar bloqueado para o usuario até que que clique em Novo
           jTextFieldUsuario.setEnabled(false);
           jComboBoxTipo.setEnabled(false);
           jPasswordFieldSenha.setEnabled(false);
           jPasswordFieldConfirmSenha.setEnabled(false);
           jButtonSalvar.setEnabled(false);
           jButtonCancelar.setEnabled(false);
           jButtonAlterar.setEnabled(false);
           jButtonExcluir.setEnabled(false);
           jButtonNovo.setEnabled(true); // habilita o Novo  
           
           preencherTabela("select *from usuarios order by nome_usuario");  
      
    }//GEN-LAST:event_jButtonExcluirActionPerformed
    }
    private void jButtonCancelarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonCancelarActionPerformed
        //bloquear os campos
        jTextFieldUsuario.setEnabled(!true);
        jComboBoxTipo.setEnabled(!true);
        jPasswordFieldSenha.setEnabled(!true);
        jPasswordFieldConfirmSenha.setEnabled(!true);
       
        
       // habilita o botão de Novo
        jButtonNovo.setEnabled(true); //ativa botão de novo
        jButtonAlterar.setEnabled(false);
        jButtonExcluir.setEnabled(false);
        jButtonSalvar.setEnabled(false);
        jButtonBuscar.setEnabled(false);
        jButtonCancelar.setEnabled(false);
        jTextFieldCod.setText("");
        jTextFieldUsuario.setText("");
        jPasswordFieldSenha.setText("");
        jPasswordFieldConfirmSenha.setText("");
        preencherTabela("select *from usuarios order by nome_usuario");
    }//GEN-LAST:event_jButtonCancelarActionPerformed

    private void jTableUsuarioMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jTableUsuarioMouseClicked
        // ao clicar em um dado da tabel, irá preencher os dados e habilitar opção de Editar e Excluir 
        String nome_usua =(String)jTableUsuario.getValueAt(jTableUsuario.getSelectedRow(), 1); 
       conexao.conexao();
       conexao.executaSql("select *from usuarios where nome_usuario ='"+ nome_usua+"'");
        try {
          
            conexao.rs.next();
            jTextFieldCod.setText(String.valueOf(conexao.rs.getInt("cod_usuario")));
            jTextFieldUsuario.setText(conexao.rs.getString("nome_usuario"));
            jPasswordFieldSenha.setText(conexao.rs.getString("senha_usuario"));
            jPasswordFieldConfirmSenha.setText(conexao.rs.getString("senha_usuario"));
            jComboBoxTipo.setSelectedItem(conexao.rs.getString("tipo_usuario"));
          
            jButtonNovo.setEnabled(false);
            jButtonAlterar.setEnabled(true);
            jButtonExcluir.setEnabled(true);
            jButtonCancelar.setEnabled(true);
        
        } catch (SQLException ex) {
           JOptionPane.showMessageDialog(null,"Erro ao selecionar os dados"+ ex);
        }
       
       
       conexao.desconecta();
    }//GEN-LAST:event_jTableUsuarioMouseClicked
    public void preencherTabela(String Sql){
        ArrayList dados = new ArrayList();   
        String [] colunas = new String[]{"ID","Nome_Usuario","Senha","Tipo_Usuario"};
        conexao.conexao();
        conexao.executaSql(Sql);
        
        try{
            conexao.rs.first();
            do{
                dados.add(new Object[]{conexao.rs.getInt("cod_usuario"),conexao.rs.getString("nome_usuario"),conexao.rs.getString("senha_usuario"),conexao.rs.getString("tipo_usuario")});
                
                
            }while(conexao.rs.next()); //enquanto houver dados irá percorrer os dados
        
    }catch(SQLException ex){
            JOptionPane.showMessageDialog(rootPane, "Usuario não cadastrado. Realizar Nova Busca");
           
            }
        Tabela modelo = new Tabela(dados, colunas);
        jTableUsuario.setModel(modelo);
        //coluna ID
        jTableUsuario.getColumnModel().getColumn(0).setPreferredWidth(30);//  tamanho da coluna
        jTableUsuario.getColumnModel().getColumn(0).setResizable(false); // não pode alterar tamanho da tabela
        //coluna nome
        jTableUsuario.getColumnModel().getColumn(1).setPreferredWidth(210);//  tamanho da coluna
        jTableUsuario.getColumnModel().getColumn(1).setResizable(false); // não pode alterar tamanho da tabela        
        //coluna senha
        jTableUsuario.getColumnModel().getColumn(2).setPreferredWidth(140);//  tamanho da coluna
        jTableUsuario.getColumnModel().getColumn(2).setResizable(false); // não pode alterar tamanho da tabela   
        //coluna tipo
        jTableUsuario.getColumnModel().getColumn(3).setPreferredWidth(200);//  tamanho da coluna
        jTableUsuario.getColumnModel().getColumn(3).setResizable(false); // não pode alterar tamanho da tabela 
        
        
        jTableUsuario.getTableHeader().setReorderingAllowed(false);// não pode reordenar
        jTableUsuario.setAutoResizeMode(jTableUsuario.AUTO_RESIZE_OFF);//não pode redimensionar
        jTableUsuario.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);//seleciona um item por vez
        conexao.desconecta();
        
    }        
    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        /* Set the Nimbus look and feel */
        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        /* If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
         * For details see http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html 
         */
        try {
            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
                if ("Nimbus".equals(info.getName())) {
                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
                    break;
                }
            }
        } catch (ClassNotFoundException ex) {
            java.util.logging.Logger.getLogger(CadastroUsuario.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (InstantiationException ex) {
            java.util.logging.Logger.getLogger(CadastroUsuario.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (IllegalAccessException ex) {
            java.util.logging.Logger.getLogger(CadastroUsuario.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (javax.swing.UnsupportedLookAndFeelException ex) {
            java.util.logging.Logger.getLogger(CadastroUsuario.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }
        //</editor-fold>

        /* Create and display the form */
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new CadastroUsuario().setVisible(true);
            }
        });
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton jButtonAlterar;
    private javax.swing.JButton jButtonBuscar;
    private javax.swing.JButton jButtonCancelar;
    private javax.swing.JButton jButtonExcluir;
    private javax.swing.JButton jButtonNovo;
    private javax.swing.JButton jButtonSalvar;
    private javax.swing.JComboBox<String> jComboBoxTipo;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPasswordField jPasswordFieldConfirmSenha;
    private javax.swing.JPasswordField jPasswordFieldSenha;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JTable jTableUsuario;
    private javax.swing.JTextField jTextFieldCod;
    private javax.swing.JTextField jTextFieldPesquisar;
    private javax.swing.JTextField jTextFieldUsuario;
    // End of variables declaration//GEN-END:variables
}
